searchNodes=[{"doc":"","ref":"Example.html","title":"Example","type":"module"},{"doc":"","ref":"Example.html#double/1","title":"Example.double/1","type":"function"},{"doc":"","ref":"Example.html#function_with_26_arguments/26","title":"Example.function_with_26_arguments/26","type":"function"},{"doc":"","ref":"Example.html#function_with_multiple_arities/1","title":"Example.function_with_multiple_arities/1","type":"function"},{"doc":"","ref":"Example.html#function_with_multiple_arities/2","title":"Example.function_with_multiple_arities/2","type":"function"},{"doc":"","ref":"Example.html#function_with_multiple_arities/3","title":"Example.function_with_multiple_arities/3","type":"function"},{"doc":"Patch - Ergonomic Mocking for Elixir Patch makes it easy to mock one or more functions in a module returning a value or executing custom logic. Patches and Spies allow tests to assert or refute that function calls have been made. Patches When a module is patched, the patched function will return the value provided. assert &quot;HELLO&quot; = String.upcase(&quot;hello&quot;) # Assertion passes before patching patch(String, :upcase, :patched_return_value) assert :patched_return_value == String.upcase(&quot;hello&quot;) # Assertion passes after patching Modules can also be patched to run custom logic instead of returning a static value assert &quot;HELLO&quot; = String.upcase(&quot;hello&quot;) # Assertion passes before patching patch(String, :upcase, fn s -&gt; String.length(s) end) assert 5 == String.upcase(&quot;hello&quot;) # Assertion passes after patching Patching Ergonomics patch/3 returns the value that the patch will return which can be useful for later on in the test. Examine this example code for an example {:ok, expected} = patch(My.Module, :some_function, {:ok, 123}) ... additional testing code ... assert response.some_function_result == expected This allows the test author to combine creating fixture data with patching. Asserting / Refuting Calls After a patch is applied, tests can assert that an expected call has occurred by using the assert_called macro. patch(String, :upcase, :patched_return_value) assert :patched_return_value = String.upcase(&quot;hello&quot;) # Assertion passes after patching assert_called String.upcase(&quot;hello&quot;) # Assertion passes after call assert_called supports the :_ wildcard atom. In the above example the following assertion would also pass. assert_called String.upcase(:_) This can be useful when some of the arguments are complex or uninteresting for the unit test. Tests can also refute that a call has occurred with the refute_called macro. This macro works in much the same way as assert_called and also supports the :_ wildcard atom. Spies If a test wishes to assert / refute calls that happen to a module without actually changing the behavior of the module it can simply spy/1 the module. Spies behave identically to the original module but all calls and return values are recorded so assert_called and refute_called work as expected.","ref":"Patch.html","title":"Patch","type":"module"},{"doc":"Asserts that the function has been called with any arity call","ref":"Patch.html#assert_any_call/2","title":"Patch.assert_any_call/2","type":"function"},{"doc":"","ref":"Patch.html#assert_called/1","title":"Patch.assert_called/1","type":"macro"},{"doc":"Patches a function in a module The patched function will either always return the provided value or if a function is provided then the function will be called and its result returned.","ref":"Patch.html#patch/3","title":"Patch.patch/3","type":"function"},{"doc":"Refutes that the function has been called with any arity call","ref":"Patch.html#refute_any_call/2","title":"Patch.refute_any_call/2","type":"function"},{"doc":"","ref":"Patch.html#refute_called/1","title":"Patch.refute_called/1","type":"macro"},{"doc":"Remove any mocks or spies from the given module","ref":"Patch.html#restore/1","title":"Patch.restore/1","type":"function"},{"doc":"Spies on the provided module Once a module has been spied on the calls to that module can be asserted / refuted without changing the behavior of the module.","ref":"Patch.html#spy/1","title":"Patch.spy/1","type":"function"},{"doc":"For simple patching the caller can just patch a function, ignore the arguments, and always return a value. This module helps create anonymous functions that accept (and ignore) the requested number of arguments and always return the static value. This module was autogenerated, it contains 255 for_arity/2 clauses that all behave identically only differing in the number of arguments the anonymous function accepts. mix format wants this to be several thousand lines long, so it&#39;s getting put over here to keep the main Patch module small and easy to read. TODO: Find a better way to do this.","ref":"Patch.Function.html","title":"Patch.Function","type":"module"},{"doc":"Generate an anonymous function of the arity provided that ignores all arguments and returns the provided return_value. BEAM only supports functions of arity /0 though /254.","ref":"Patch.Function.html#for_arity/2","title":"Patch.Function.for_arity/2","type":"function"},{"doc":"","ref":"Patch.MissingCall.html","title":"Patch.MissingCall","type":"exception"},{"doc":"","ref":"Patch.UnexpectedCall.html","title":"Patch.UnexpectedCall","type":"exception"},{"doc":"Patch Patch - Ergonomic Mocking for Elixir Patch makes it easy to mock one or more functions in a module returning a value or executing custom logic. Patches and Spies allow tests to assert or refute that function calls have been made.","ref":"readme.html","title":"Patch","type":"extras"},{"doc":"Add patch to your mix.exs def deps do [ {:patch, &quot;~&gt; 0.2.0&quot;, only: [:test]} ] end","ref":"readme.html#installation","title":"Patch - Installation","type":"extras"},{"doc":"After adding the dependency just add the following line to any test module after using your test case use Patch","ref":"readme.html#quickstart","title":"Patch - Quickstart","type":"extras"},{"doc":"When a module is patched, the patched function will return the value provided. assert &quot;HELLO&quot; = String.upcase(&quot;hello&quot;) # Assertion passes before patching patch(String, :upcase, :patched_return_value) assert :patched_return_value == String.upcase(&quot;hello&quot;) # Assertion passes after patching Modules can also be patched to run custom logic instead of returning a static value assert &quot;HELLO&quot; = String.upcase(&quot;hello&quot;) # Assertion passes before patching patch(String, :upcase, fn s -&gt; String.length(s) end) assert 5 == String.upcase(&quot;hello&quot;) # Assertion passes after patching Patching Ergonomics patch/3 returns the value that the patch will return which can be useful for later on in the test. Examine this example code for an example {:ok, expected} = patch(My.Module, :some_function, {:ok, 123}) ... additional testing code ... assert response.some_function_result == expected This allows the test author to combine creating fixture data with patching.","ref":"readme.html#patches","title":"Patch - Patches","type":"extras"},{"doc":"After a patch is applied, tests can assert that an expected call has occurred by using the assert_called macro. patch(String, :upcase, :patched_return_value) assert :patched_return_value = String.upcase(&quot;hello&quot;) # Assertion passes after patching assert_called String.upcase(&quot;hello&quot;) # Assertion passes after call assert_called supports the :_ wildcard atom. In the above example the following assertion would also pass. assert_called String.upcase(:_) This can be useful when some of the arguments are complex or uninteresting for the unit test. Tests can also refute that a call has occurred with the refute_called macro. This macro works in much the same way as assert_called and also supports the :_ wildcard atom. Multiple Arities If a function has multiple arities that may be called based on different conditions the test author may wish to assert or refute that a function has been called at all without regards to the number of arguments passed. This can be accomplished with the assert_any_call/2 and refute_any_call/2 functions. These functions take two arguments the module and the function name as an atom.","ref":"readme.html#asserting-refuting-calls","title":"Patch - Asserting / Refuting Calls","type":"extras"},{"doc":"If a test wishes to assert / refute calls that happen to a module without actually changing the behavior of the module it can simply spy/1 the module. Spies behave identically to the original module but all calls and return values are recorded so assert_called and refute_called work as expected.","ref":"readme.html#spies","title":"Patch - Spies","type":"extras"}]